<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCabLiqERP ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfCabLiqERP
 * @subpackage Arrays
 */
class ArrayOfCabLiqERP extends AbstractStructArrayBase
{
    /**
     * The CabLiqERP
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CabLiqERP[]
     */
    public $CabLiqERP;
    /**
     * Constructor method for ArrayOfCabLiqERP
     * @uses ArrayOfCabLiqERP::setCabLiqERP()
     * @param \StructType\CabLiqERP[] $cabLiqERP
     */
    public function __construct(array $cabLiqERP = array())
    {
        $this
            ->setCabLiqERP($cabLiqERP);
    }
    /**
     * Get CabLiqERP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CabLiqERP[]|null
     */
    public function getCabLiqERP()
    {
        return isset($this->CabLiqERP) ? $this->CabLiqERP : null;
    }
    /**
     * Set CabLiqERP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\CabLiqERP[] $cabLiqERP
     * @return \ArrayType\ArrayOfCabLiqERP
     */
    public function setCabLiqERP(array $cabLiqERP = array())
    {
        foreach ($cabLiqERP as $arrayOfCabLiqERPCabLiqERPItem) {
            // validation for constraint: itemType
            if (!$arrayOfCabLiqERPCabLiqERPItem instanceof \StructType\CabLiqERP) {
                throw new \InvalidArgumentException(sprintf('The CabLiqERP property can only contain items of \StructType\CabLiqERP, "%s" given', is_object($arrayOfCabLiqERPCabLiqERPItem) ? get_class($arrayOfCabLiqERPCabLiqERPItem) : gettype($arrayOfCabLiqERPCabLiqERPItem)), __LINE__);
            }
        }
        if (is_null($cabLiqERP) || (is_array($cabLiqERP) && empty($cabLiqERP))) {
            unset($this->CabLiqERP);
        } else {
            $this->CabLiqERP = $cabLiqERP;
        }
        return $this;
    }
    /**
     * Add item to CabLiqERP value
     * @throws \InvalidArgumentException
     * @param \StructType\CabLiqERP $item
     * @return \ArrayType\ArrayOfCabLiqERP
     */
    public function addToCabLiqERP(\StructType\CabLiqERP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CabLiqERP) {
            throw new \InvalidArgumentException(sprintf('The CabLiqERP property can only contain items of \StructType\CabLiqERP, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->CabLiqERP[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CabLiqERP|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CabLiqERP|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CabLiqERP|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CabLiqERP|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CabLiqERP|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CabLiqERP
     */
    public function getAttributeName()
    {
        return 'CabLiqERP';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfCabLiqERP
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
